/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Sat Oct 14 10:31:24 CDT 2000
    copyright            : (C) 2000 by Sean Truman
    email                : sean.truman@prodigysolutions.com
    qmail-smtpd support  : (C) 2004 by Erwin Hoffmann (feh@fehcom.de)
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <strings.h>

int main(int argc, char **argv)
{
    int c;
	int enoughtime = 0;
	int local = 0;
	int remote = 0;
	int success = 0;
	int failure = 0;
	int bytes = 0;

	int asessions = 0;
	int rsessions = 0;
	int aorig = 0;
	int arcpt = 0;
	int rsend = 0;
	int rhelo = 0;
	int rorigbad = 0;
	int rorigdns = 0;
	int rrcptbad = 0;
	int rrcptfail = 0;
	int rmime = 0;
	int rloader = 0;
	int rvirus = 0;
	int rspam = 0;
	int aauth = 0;
	int rauth = 0;
	int astls = 0;
	int rstls = 0;
	int ok = 0;
        int deny = 0;
	int rbl = 0;
	
	//unsigned long logseconds;
	unsigned long seconds;
  unsigned long nanoseconds;
	char buff[4072];
	//char buff2[4072];
	//char tmp[4072];
	char *tmp1;
	char *tmp2;
	char *tmp3;
	char *tmp4;
	//char *pbuff = buff;
	time_t current_time = 0;
	current_time = time(NULL);
	if (argc < 2) {
		printf("Usage: qmail-mrtg [ -v | -1 | -2 | -3 | -4 | -5 | -6 | -7 | -8 | -9 | -10 | -11 | -12 | -13| -14 ]\n");
	  printf("\t-v = Verbose\n");
		printf("\t-1 = Message Success/Failure\n");
		printf("\t-2 = Message Bytes\n");
		printf("\t-3 = Local/Remote Concurrency\n");
		printf("\t-4 = Total Messages Sent\n");
		printf("\t-5 = Total SMTPD Sessions \n");
		printf("\t-6 = Accepted SMTPD Sessions \n");
		printf("\t-7 = Rejected SMTPD Sessions \n");
		printf("\t-8 = Rejected SMTPD Originator \n");
		printf("\t-9 = Rejected SMTPD Recipient \n");
		printf("\t-10 = Rejected SMTPD Mime + Loader \n");
		printf("\t-11 = Rejected SMTPD Virus + Spam \n");
		printf("\t-12 = Authenticated SMTPD Sessions \n");
		printf("\t-13 = STARTTLS SMTPD Sessions \n");
		printf("\t-14 = tcpserver/sslserver/rblsmtpd connections \n");
		return(0);
	}
	while ((c = getchar()) != EOF) {
        if (c == '@') {
		    int c;
   			unsigned long u;
			while ((c = getchar()) != EOF) {
		        u = c - '0';
		        if (u >= 10) {
		            u = c - 'a';
		            if (u >= 6) break;
		            u += 10;
		        }
		        seconds <<= 4;
		        seconds += nanoseconds >> 28;
		        nanoseconds &= 0xfffffff;
		        nanoseconds <<= 4;
		        nanoseconds += u;
		    }
		    seconds -= 4611686018427387914ULL;
			if (enoughtime) {
				if (seconds <= current_time && seconds >= (current_time-300)) {
				c = getchar();
				while (c != EOF) {
					if (c == '\n') break;
					sprintf(buff,"%s%c",buff,c);
					c = getchar();
		       		}
				if((strstr(buff,"status:")) && (strstr(buff,"remote"))){
					tmp3 = strstr(buff," remote ");
					tmp4 = strstr(tmp3+8,"/");
					tmp3[strlen(tmp3)-(strlen(tmp4)-1)] = 0;
					if (atoi(tmp3+8) > remote) {
						remote = atoi(tmp3+8);
					}
	
				}
				if(!strcmp(argv[1],"-v")) {
					printf("%lu.%lu ",seconds, nanoseconds);
					printf("%s\n",buff);
				}
				if(strstr(buff,"success:")) success++;
				if(strstr(buff,"failure:")) failure++;
				if(strstr(buff,": bytes ")) {
					tmp1 = strstr(buff,": bytes");
					tmp2 = strstr(tmp1+8," ");
					tmp1[strlen(tmp1)-strlen(tmp2)] = 0;
					bytes=bytes+atoi(tmp1+8);
				}
				if((strstr(buff,"status:")) && (strstr(buff," local "))){
					tmp1 = strstr(buff," local ");
					tmp2 = strstr(tmp1+7,"/");
					tmp1[strlen(tmp1)-(strlen(tmp2)-1)] = 0;
					if (atoi(tmp1+7) > local) {
						local = atoi(tmp1+7);
					}
				}

				if(strstr(buff,"Accept:")) asessions++; 		/* -5*/
				if(strstr(buff,"Reject:")) rsessions++;

				if(strstr(buff,"Accept::ORIG:")) aorig++;		/* -6*/
				if(strstr(buff,"Accept::RCPT:")) arcpt++;

				if(strstr(buff,"Reject::SNDR::Invalid_Relay:")) rsend++; /* -7*/
				if(strstr(buff,"Reject::SNDR::Bad_Helo:")) rhelo++; 
				if(strstr(buff,"Reject::SNDR::DNS_Helo:")) rhelo++; 

				if(strstr(buff,"Reject::ORIG::Bad_Mailfrom:")) rorigbad++;  /* -8*/
				if(strstr(buff,"Reject::ORIG::DNS_MF:")) rorigdns++; 

				if(strstr(buff,"Reject::RCPT::Bad_Rcptto:")) rrcptbad++; /* -9*/
				if(strstr(buff,"Reject::RCPT::Failed_Rcptto:")) rrcptfail++;

				if(strstr(buff,"Reject::DATA::Bad_MIME")) rmime++;	/* -10*/
				if(strstr(buff,"Reject::DATA::Bad_Loader")) rloader++;

				if(strstr(buff,"Reject::DATA::Virus_Infected")) rvirus++; /* -11*/
				if(strstr(buff,"Reject::DATA::Spam_Message")) rspam++;
					
				if(strstr(buff,"Info::ORIG::Valid_Auth")) aauth++;	/* -12*/
				if(strstr(buff,"Reject::ORIG::Failed_Auth")) rauth++;
				if(strstr(buff,"Reject::ORIG::Missing_Auth")) rauth++;
					
				if(strstr(buff,"Info::SNDR::Start_TLS")) astls++;	/* -13*/
				if(strstr(buff,"Reject::SNDR::Missing_TLS")) rstls++;
				if(strstr(buff,"Reject::SNDR::Reject_TLS")) rstls++;
					
				if(strstr(buff,": ok")) ok++;				/* -14*/
				if(strstr(buff,": deny")) deny++;
				if(strstr(buff,"rblsmtpd:") && strstr(buff,": 451")) rbl++;
				if(strstr(buff,"rblsmtpd:") && strstr(buff,": 553")) rbl++;
					
				sprintf(buff,"");
				} else {
					while (c != EOF) {
						if (c == '\n') break;
						c = getchar();
					}
				}
				}
			} else {
				if(!seconds) {
					printf("Log file seems to be empty or log file bad\n");
					return(-1);
				} else {
					enoughtime++;
				}
			}
	    }
	if(!strcmp(argv[1],"-1")) {
		printf("%i\n",success);
		printf("%i\n",failure);
	}
	if(!strcmp(argv[1],"-2")) {
		printf("%i\n",bytes/1024);
		printf("%i\n",bytes/1024);
	}
	if(!strcmp(argv[1],"-3")) {
		printf("%i\n",local);
		printf("%i\n",remote);
	}
	if(!strcmp(argv[1],"-4")) {
		printf("%i\n",success);
		printf("%i\n",failure+success);
        }
	if(!strcmp(argv[1],"-5")) {
		printf("%i\n",asessions);
		printf("%i\n",rsessions);
	}
	if(!strcmp(argv[1],"-6")) {
		printf("%i\n",aorig);
		printf("%i\n",arcpt);
	}
	if(!strcmp(argv[1],"-7")) {
		printf("%i\n",rsend);
		printf("%i\n",rhelo);
	}
	if(!strcmp(argv[1],"-8")) {
		printf("%i\n",rorigbad);
		printf("%i\n",rorigdns);
	}
	if(!strcmp(argv[1],"-9")) {
		printf("%i\n",rrcptbad);
		printf("%i\n",rrcptfail);
	}
	if(!strcmp(argv[1],"-10")) {
		printf("%i\n",rmime);;
		printf("%i\n",rloader);
	}
	if(!strcmp(argv[1],"-11")) {
		printf("%i\n",rvirus);;
		printf("%i\n",rspam);
	}
	if(!strcmp(argv[1],"-12")) {
		printf("%i\n",aauth);
		printf("%i\n",rauth);
	}
	if(!strcmp(argv[1],"-13")) {
		printf("%i\n",astls);
		printf("%i\n",rstls);
	}
	if(!strcmp(argv[1],"-14")) {
		printf("%i\n",ok);
		printf("%i\n",deny+rbl);
	}
}
